Wprowadzenie

 LC Początek LC Następna

Program UPS-CAD to program do zaprojektowania i dostosowania do Twojej drukarki dowolnego kuponu gry Lotto lub TOTO. W porównaniu do innych programów drukujących kupony, program wyróżnia się oryginalnym algorytmem tworzenia kuponów. W kilku prostych krokach posługując się linijką lub suwmiarką i myszką można zaprojektować własny kupon gry LOTTO lub TOTO (zakłady piłkarskie).

Po utworzeniu kuponu można z programu drukować własne systemy i zestawy zakładów bez możliwości popełnienia błędu przy przepisywaniu.

Program można stosować dla wszystkich gier LOTTO, KENO, TOT PIŁKARSKIE i nawet gry liczbowe (układowe) np PICK3(4).

Uniwersalność programu jest zapewniona przez unikalne rozwiązania programistyczne. Zapewne również potrafi obsłużyć gry w krajach gdzie czyta sie i pisze z prawej do lewej strony.

Program jest bardzo łatwy w obsłudze i jest w stanie dostarczyć Ci wiele zadowolenia z wkladu własnej pracy w stworzenie kuponu.

Po utworzeniu kuponu, lub zestawu kuponów program drukuje z listy zakładów zapisanych w edytorze tekstowym lub po prostu wklejonych z Twojego programu lotto.

powodzenia

Autor

Wojtek Jarzęcki

P.P.H. WojarSoft


Podstawowe pojęcia.

Wyjaśnienie pojęć

 LC Początek LC Poprzednia LC Następna
KUPON | Kupon do gry Lotto lub TOTO (jaki jest każdy widzi). |
PANEL | Sekcja (ramka) na kuponie obejmująca wszystkie liczby (np 1..49 dla gry Lotto) lub dla paneli specjalnych kolejne wybory opcji (ilość losowań, system, ilość skreśleń /KENO/, stawka /KENO/). Granice kuponu oznaczone ramką. | ramka
MARKER | Pole (ramka, prostokąt) obejmujące pojedyncze pole liczby np pole liczby [1] lub pole wyboru. Zwykle wymiary tego pola są dla całego kuponu jednakowe. Granice pola oznaczone ramką | marker
WYMIARY | Wymiary mogą byc podawane w milimetrach lub calach. Uwaga wymiary zawsze podajemy jako szerokość lub wysokość w ten sposób jak kupon jest drukowany (zwykle szerokość to węższa krawędź kuponu). Położenie kuponu ustalamy zawsze tak jak jest drukowany. Natomiast położenie paneli (wysokość i szerokość) ustalamy tak jak czytamy liczby na panelu. Czyli krawedź górna panela ustawionego tak jak czyta sie liczby z jego pól, to krawędź wg której określamy szerokość panela. Te zasady umożliwiaja prawidłowe pozycjonowanie paneli ich obrót i np lustrzane odbicie. Ta sama zasada jak dla paneli obowiązuje dla pola liczby. Szerokość pola liczby to szerokość górnej krawedzi tego pola. | kupon
LICZBY, WIERSZE I KOLUMNY | Każdy panel na kuponie oznacza liczbę lub opcję wyboru. Wg przykładu na obrazie obok panel ma 6 wierszy, 7 kolumn i 39 liczb. | panel
RODZAJ PANELA | Podczas wstawiania paneli trzeba okreslić rodzaj panela, rodzaje te są zdefiniowane w programie. Wybór rodzaju to wybór z rozwijalnej listy podczas projektowania panela. | 1. Normalny panel typowania. 2. Panel liczby dodatkowej (Numerek) 3. Panel ilości skreśleń (np Multi 1 ..10) 4. Panel ilości losowań (na ile gier zawiera się zakłady). 5. Panel stawki gry (multi stawka x1 ..10) 6. Panel wyboru gry (Wybór np Duzy Lotek, Express Lotek) 7. Specjalny panel bez określonej funkcji (do wykorzystania w przyszłości) 8. Panel systemu gry (np Duży Lotek 7..12 skreśleń systemowych. 9. Panel znacznik , panel używany do zaznaczenia pojedynczego markera. Znacznika na kuponie. 10. Normalny Panel Typowania do gry TOTO. 11. Panel gry Pick3(x) gra na pozycje liczb losowanych.Np Pick3 ma 1000 kombinacji. 3 liczby w kombinacjach od 0,0,0 do 9,9,9.


Jak zacząć.

Program umożliwia zaprojektowanie kuponów na dwa sposoby:

1. Metoda pomiarowa (linijka lub suwmiarka).

metoda wymaga pomiarów położenia elementów (paneli i pól) na kuponie. Tych pomiarów nie jest wiele, wystarcza dość dokładne 3-4 pomiary, reszta elementów zwykle jest powtarzalna i nie wymaga wielokrotnego mierzenia.

2. Metoda z szablonem (zdjęcie lub skan kuponu).

Metoda ta wymaga wykonania zdjęcia (obrazka) zrobionego np aparatem cyfrowym (telefonem komórkowym) lub zeskanowanym obrazem kuponu. Obraz służy jako szablon i ułatwia znakomicie pozycjonowanie paneli na kuponie. Podstawowe wymiary w tej metodzie musimy również podawać.


Metoda z szablonem

Metoda ta pozwala wykorzystać obraz kuponu sfotografowanego lub zeskanowanego czystego kuponu który służyć będzie jako tło (szablon) co znakomicie ułatwia pozycjonowanie paneli podczas projektowania. Zdjęcie można wykonać nawet aparatem cyfrowym z komórki.


Szablon - krok 1

Do zeskanowania kuponu użyć możemy skanera lub aparatu cyfrowego. W przykładzie uzyłem zdjęcie zrobione z reki z pomocą komórki C902 Sony Ericsson. Ważne aby wykonać zdjęcie mozliwie równolegle do jego brzegów. Zrobione zdjęcie zapisujemy na dysk. Program posiada funkcje umożliwiające obcięcie zdjęcia i wykorzystanie proporcji zdjecia do wykonania realnego szablonu kuponu.

1. Z menu wybieramy opcję >> Narzędzia >> Otwórz obraz lub skan.

2. Obraz należy dokladnie dociąć do granic papieru i ewentualnie skorygowac położenie.

3. Obcinamy, jeżeli nie widzimy całego obrazu (jest duży) wybierz powiekszenie (skalę) wyswietlania obrazu. Pozwoli to obciąć obraz do granic papieru.

skala

4. Do obcinania służy ramka którą wywołujemy z menu podręcznego rys 2. (prawy przycisk myszki). Posługując się narzedziami "skala" i "ramka obcinania", ustawiamy ramkę na granicę papieru kuponu na zdjeciu i z tego samego menu podrecznego wybieramy polecenie "obetnij obraz".

menu-ramka obcinania

5. Zdjęcie obciete do brzegów papieru można już zwymiarować. Mierzymy suwmiarka lub linijką dość dokładnie wymiary realnego kuponu i wpisujemy je do pól menu "file">>"Szerokość kuponu">>"Wysokość kuponu". Wpisujemy również w pole "Nazwa projektu" jego nazwę np "Multi Multi 1".

menu pliki

6. Na bazie zdjęcia tworzymy projekt, wybierając z tego samego menu "Pliki" polecenie "Nowy projekt na bazie obrazu".

Projekt jest gotowy do wstawiania Paneli.


Panele krok 2

Pomiary krok 2

Aby wstawić panele na kupon należy okreslić ich wymiary. Panel mierzy się od górnej lewej granicy pola liczbowego do dolnej prawej granicy skrajnego pola. W metodzie pomiarowej ten pomiar robi sie linijka lub suwmiarka w tej metodzie "zmierzyć" można na ekranie myszką.

Pomiar panela z pomoca ramki pomiarowej

Pomiar panela z pomoca ramki pomiarowej

Z menu podręcznego wybierz polecenie "ramka pomiarowa".Przesuń ramkę na granice panelu na obrazie kuponu na ekranie. Przykład jest na rysunku powyżej.

Na pasku stanu odczytasz z pola wymiary wartość szerokości i wysokości ramki.

wynik pomiaru panela

wynik pomiaru panela

W tym przykładzie nie trzeba obracać panelem. I szerokość i wysokość odczytujemy wprost. Na kuponie np "Dużego Lotka" panel trzeba obrócić o 90 stopni w prawo wówczas podczas pomiaru trzeba pamiętać że szerokość to górna krawędź panelu patrząc na niego w ten sposób że czytamy liczby normalnie. Dla Dużego Lotka wymiary trzeba zamienić. Wymiary odczytane z paska stanu zanotuj.

Ostatni pomiar to pomiar pojedynczego pola liczby. Tą samą ramkę przesuń tak aby obejmowała tylko jedno pole liczbowe.

Pomiar pojedynczego pola liczby

Pomiar pojedynczego pola liczby

Aby zrobić to precyzyjnie możesz posłużyć się powiększeniem "Skala" np 5x lub 10x, wówczas precyzyjnie zmierzysz pole. Wyniki zapamiętaj.

Wynik pomiaru pojedyńczego pola liczby

Wynik pomiaru pojedyńczego pola liczby

Mozna wstawiać już panele.


Panele tworzenie krok 3

Z menu podręcznego wybierz opcję "Dodaj Panel", Wyświetli się formularz :

formularz paneli

Po wpisaniu wartości :

sekcja | właściwość | opis
Panel pozycja i rozmiary | od lewej | Pozycja wstawiania panelu po wciśnięciu przycisku OK. To odległość od lewego górnego rogu papieru do lewego górnego punktu panela w momencie wstawiania. Można tu nic nie wpisywać, pozostawić zera, wówczas panel za każdym razem wstawiany będzie w lewym górnym narożniku papieru. Odległość ta i tak będzie zmieniana automatycznie podczas przesuwania panela myszką i jego pozycjonowania.
 | od prawej
 | szerokość | Zmierzone rozmiary panela. UWAGA: na kuponach panel jest odwrócony o 90 stopni od kierunku drukowania.Szerokość panela to zawsze krawędź górna określona dla takiego jego położenia dla którego możemy normalnie czytać liczby.
 | wysokość
Rozmiar pola liczby | szerokość | Zmierzone rozmiary pojedynczego pola liczby. Uwaga : Położenie rozmiarów jak w powyższej uwadze
 | wysokość
Dane i rodzaj panela | ilość liczb (pozycji) na panelu | Ilość wszystkich liczb (pól liczbowych) na panelu. Np w grze MultiMulti to 80 pól liczbowych. Dla paneli specjalnych podaje sie ilość pól liczbowych. Podczas drukowania kuponu podaje się numer kolejny który ma być wypełniony na czarno (marker)/znacznik/
 | ilość wierszy | ilość wierszy na panelu dla MultMulti wynosi 8
 | ilość kolumn | ilość kolumn na panelu dla Multi Multi wynosi 10
 | rodzaj panela | Wybierz z rozwijalnej listy rodzaj panela. Dostępnych jest 11 rodzai paneli : 1. Normalny panel typowania. 2. Panel dla gry z dwoma zestawami liczb (Numerek). 3. Panel ilosci skreślen na kuponie (Multi Multi 1 do 10). 4. Panel ilości losowań w jakich zakład uczestniczy (Multi Multi 15 pozycji). 5. Panel stawki gry (MM x1 do x10). 6. Panel wyboru gry (wybór gry np. Duży, Express). 7. Panel specjalny (do własnych zastosowań). 8. Panel systemu gry (DL System 7 do12). 9. Pojedynczy Panel z jednym znacznikiem (MM oznaczenie gry PLUS). 10. Panel gry Totalizator Piłkarski (Np TOTO Niemcy). 11. Panel gry układowej (np PICK 3 Illinois Lotery Chicage USA).
Dane i rodzaj panela | Wybierz lub wpisz nową nazwę panela | Pole służy do wyboru zapamiętanych paneli. Wybór jednocześnie wpisuje w pola zapamiętane wartości i wymiary panela. Jeżeli tworzysz nowy panel wpisz w to pole jego nowa unikalną nazwę. Wówczas utworzony zostanie nowy panel z wartościami zerowymi.


Panele wstawianie krok 4

Jeżeli utworzyłeś panel i na kuponie jest ich więcej nie musisz już ich tworzyć za każdym razem. Np dla przykładowego kuponu wybierz z menu podręcznego (prawy myszki) polecenie "Dodaj panel" trzykrotnie i umieść panele na swoich miejscach, choć zgrubnie w powiększeniu x1. Następnie wybierz powiększenie wieksze np x3 lub x5 i precyzyjnie poumieszczaj panele na swoich miejscach.

Program ma udogodnienia w pozycjonowaniu. Klawisze CTRL, ALT i SHIFT blokują chwilowo jeden z kierunków przesuwania panela myszka. Po wciśnięciu jednego z tych klawiszy w pasku stanu pokazuje sie ikona z oznaczeniem jaki kierunek przesuwania jest aktywny (dozwolony).

Np: Jeżeli ustawiłeś dobrze panel w poziomie a chcesz go precyzyjnie przesunąć w pionie, wcisnij klawisz ALT. Pokaże się ikonka pion1. Oznacza ona że można przesuwać panel tylko w pionie. Dla klawisza CTRL ten sam efekt bedzie dla kierunku przesuwania w poziomie.

Specjalne znaczenie podczas przesuwania ma klawisz SHIFT. Jest to parkowanie na czwartego. Jeżeli chcemy ustawić panele np w 2 kolumnach i kilku rzędach to zawsze ten czwarty w sekcji (2 w wierszu, 2 w kolumnie) można wstawić automatycznie. Dostawiając czwarty panel myszką w pobliżu już wcześniej wstawionych 3 paneli poprzednich, wciśnij klawisz SHIFT i upuść myszką panel. Panel automatycznie wskoczy na miejsce odpowiadające w pionie i poziomie pozycji najbliższego sąsiada. Tak jakbyś parkował samochód jako czwarty na parkingu o 4 miejscach.

Jeżeli nie ma 2 paneli sąsiadów, klawisz ten też ułatwia pozycjonowanie np po dobrym ustawieniu poprzedniego panela. Po upuszczeniu następnego panela trzymając klawisz SHIFT, panel wskoczy na miejsce poprzednika. Teraz trzymając klawisz ALT możemy przeciągnąć go w pionie na swoje miejsce i w poziomie panel będzie miał to samo połozenie w poziomie co poprzednik. Tak samo robimy przytrzymując klawisz CTRL ale teraz nie zmieniamy położenia w pionie.

Jeżeli ustawiłeś trzy panel "normalnego typowania" na kuponie. Pora zająć sie panelami specjalnymi. Na kuponie Multi Multi jest ich kilka.


Panele specjalne krok 5

Przed wstawieniem panela specjalnego trzeba go zmierzyć. Na obrazie możemy mierzyć na ekranie. Z menu podręcznego wybierz polecenie "ramka pomiarowa". Przesuń ramkę pomiarową nad pierwszy od góry panel specjalny. Na kuponie MM pierwszy to panel ilości skreśleń.

Ustawiamy ramkę pomiarową i mamy jego wymiary (właściwie to nie trzeba mierzyć bo jego szerokość to szerokość panela typowania a jego wysokość to wysokość jednego pola):

Wybieramy polecenie "Nowy Panel" i wpisujemy nazwe nowego panela np "MM ile skreslen". Wpisujemy szerokość 61.07 a wysokość 2.00, szerokość jednego pola jak poprzednio (4.28 x 2.00) ilość pól 10 ilość wierszy 1 ilość kolumn 10, rodzaj panela "Panel ilości skresleń.

Wciskamy OK i przesuwamy panel na swoje miejsce.

Tak samo postępujemy tworząc panele specjalne " ilości losowań ", "stawki" i pojedynczy znacznik gry "plus". Jeden projekt można zapisać dla gry "plus" a drugi bez gry "plus" lub wykorzystać do tego celu "panel specjalny" wpisując przy drukowaniu wartość 1 dla gry z plusem lub pominąć wpisywanie jeżeli nie gramy z plusem.


Metoda pomiarowa

Metoda ta jest bardziej pracochłonna, ale jest dokładniejsza i warta polecenia. Przy pracy ze zdjęciem jako szablonem, suma błędów aparatu, rozdzielczości, błędów paralaksy, niedokładności naszych ocen i sprzetu powoduje że często więcej jest korekt na końcu projektu.

Pomiarów nie jest wiele i tą metodą można zrobić przy odrobinie wprawy projekt równie szybko.


Pomiary krok 1

Mierzymy suwmiarka lub linijką dość dokładnie wymiary realnego kuponu i wpisujemy je do pól menu "file">>"Szerokość kuponu">>"Wysokość kuponu". Wpisujemy również w pole "Nazwa projektu" jego nazwę np "Duży Lotek".

Projekt duży lotek

Projekt duży lotek

Wciskamy polecenie "Utwórz nowy" i mamy ramkę. Ramka ma również wyświetlone dwie( jedną parę) linii pomocniczych. Linie te w metodzie pomiarowej pełnią ważne zadanie. Z pomocą linii stworzymy siatkę ułatwiającą ustawienie paneli.

Kupon Lotto ma dwie kolumny (patrzymy zasze w kierunku drukowania) i cztery wiersze paneli typowania. Panele maja oznaczenia od 1 do 8 i w takiej kolejności będą drukowane i ustawiane na kuponie.

Mierzymy odległość lewego narożnika liczby [46] z panelu oznaczonego [2] od lewego brzegu kuponu. Wynosi ona 3.9 mm. Linię niebieską przesuwamy myszka aż stanie ona w odległosci 3.9 mm od lewego brzegu kuponu.

Linie poruszają się za myszką współbieżnie (tzw croshair) włos na krzyż :-). Aby zablokować jedną z nich wciśnij podczas przesuwania klawisz ALT lub CTRL. Ikony w pasku stanu pokazują którą linią można poruszać.

Linia niebieska będzie linią pomocniczą do ustawiania pierwszej kolumny paneli. Z uwagi na krok rozdzielczości ustawiamy linię niebieską na 4.00 mm.

Z menu podrecznego wstawiamy druga pare linii pomocniczych. Mierzymy odległosc od lewej lewego górnego rogu liczby [46] ale w panelu nr 1. Wynosi ona 41.50 mm.

Druga linie niebieska wstawiamy na 41.50 ->(41.67).

Teraz mierzymy panel czyli jego szerokość (ponieważ panel bedzie obracany a szerokość to górna krawedź panela w kierunku jak czytać można liczby) odległość od skraju pól liczb [1] i [9]. Wynosi ona 30.00 mm. Wysokość to odległość pól [1] i [46]. Wynosi ona 35.75 mm.

Mierzymy szerokość i wysokość pojedynczego pola liczb wynosi ona 2mm x 4mm.

Mierzymy odległość pola liczby [46] panela 1 lub 2, od górnego brzegu kuponu, jest równa 17.87 mm.

Teraz trzymając klawisz ALT łapiemy za linie czerwoną i przesuwamy ją na odległość 17.87 mm(17.96) od góry.

Mierzymy odległość od góry liczby [46] z paneli 3 lub 4. Odległość równa się 50.22.

Wiedząc że panele dalej porozstawiane są w równych odległościach możemy określić położenie rzędów 3 i 4.

Przesunięcie to 50.22 odjąć 17.87 = 32.35 mm.

Więc wiersz 3 będzie w odległości 50.22 plus 32.35 = 82.57 mm.

A wiersz 4 paneli będzie w odległości 82.57 plus 32.35 = 114.92 mm.

Dodamy 2 linie pomocnicze i trzymając klawisz ALT (blokada niebieskich) ustawimy początki dla wierszy 2,3 i 4.

Nasze linie są ustawione, więc wstawiamy panele.


Panele metoda pomiarowa dokończenie

Następnie tworzymy i wstawiamy panele podobnie jak w metodzie z szablonem.

w efekcie otrzymamy gotowy kupon, pozostają tylko poprawki, testowanie i drukowanie, analogicznie jak w metodzie z szablonem.

Po ustawieniu paneli linie pomocnicze można wykorzystać do ustawienia paneli specjalnych.

Pozostaje jeszcze pozycja paneli specjalnych. linia ta ma offset od ostatniej linii pomocniczej wiersza nr 4 i równa się on 33.75 mm.

Więc wstawimy jeszcze jedną linię (lub przesuniemy jedną z linii już wykorzystanych w ustawianiu paneli) w odległości od góry 114.92 plus 33.75 = 148.67

Linie pionowe ustawimy tak aby pokrywały sie z kolumnami liczbowymi :

3 kolumna początek panelu system, 6 kolumna początek panelu "ilości losowań(wielokrotne losowanie)", 8,10 lub 12 w zależności jak zapiszemy projekt (gra Zakłady Specjalne, Express Lotek lub Duży Lotek (panel Marker, Rodzaj gry).

Przy przesuwaniu linii pionowych (niebieskich) pamietamy o trzymaniu klawisza CTRL (blokada przesuwania w pionie).

Jeżeli nie używasz gry systemowej lub losowaniu wielokrotnym poprzestań tylko na markerze gry. Unikniesz wówczas pamiętania o ustawieniach paneli podczas drukowania.

Mozna też stworzyć komplet i zapisać kazdy osobno:

Duzy Lotek pojedyńcza gra

Duzy Lotek Pełny

Express Lotek pojedyncza gra

Express Lotek pełny

Zakłady specjalne

Tworzymy pełny wiec dodajemy panele:

Marker gry (pojedynczy panel z markerem), Wielokrotne losowanie (Panel ilości losowań 3 wiersze 3 kolumny, 9 pozycji) oraz Gra systemowa (3 wiersze i 3 kolumny , 9 pozycji).

Uwaga: To nie jest jedyny logiczny błąd na polskich kuponach, jest takich kilka. W grze systemowej podczas drukowania pozycja 3 oznacza grę systemem 6 skreśleniowym i kolejno 4 to system 7 ...9 to system 12 skreśleniowy. Warto o tym pamiętac.

Kompletny kupon zapisujemy na dysk.

Uwaga w procesie projektowania, każdy panel wymaga obrotu o 90 stopni. Używaj do tego opcji z menu podręcznego "Obrót o 90 stopni" . Dla ułatwienia i orientacji pola 1,2 i 3 zą znaczone kolorem znacznika.


Testowanie i drukowanie

 LC Początek LC Poprzednia

Gotowy kupon zapisz na dysku pod wybrana nazwą. Polecenie z menu Pliki>>Zapisz Projekt. Domyślne rozszerzenie nazwy pliku to ".json". Pochodzi ono od metody zapamiętywania danych JSON którą stosuje program do zapamiętywania obiektów.

Z menu Pliki>> wybieramy polecenie "Wyświetl/Schowaj Panel Drukowania i Testów"

Wpisujemy liczby testowe, tak wybrane aby obejmowały skrajne pola na panelu typowania. Test tylko obrazuje jak jest drukowany kupon. Teraz należy skorygować wszystkie błędy i niedokładności jakie popełniliśmy podczas wykonywania zdjęcia , pomiarów i pozycjonowania. Również musimy określić przesunięcie dla drukarki. Każda drukarka ma ustawione marginesy. Można to skorygować w poziomie i pionie wpisując przesuniecie korekcyjne do pól w menu pliki :"przesuń drukowanie poziomo" i "przesuń drukowanie pionowo".

Trzeba wykonać kilka testowych wydruków i ustawić tak przesuniecie aby lewy górny róg pierwszego panela typowania drukował znacznik dokładnie pośrodku liczby [1].

W naszej drukarce przesunięcie było znaczne i trzeba było wprowadzić wartości :

cztery milimetry w lewo (znak minus) i jeden milimetr w górę (znak minus). Jeżeli występuje różnica pomiędzy pozycją środkową liczb skrajnych [1] i [80] można panel lekko rozciągnąć w porządanym kierunku lub zwęzić.

Jeżeli ustawiliśmy dobrze panel numer jeden można zająć się pozostałymi. Tu może nam sie przydać inspektor obiektów. Np wszystkie panele można ustawić w pionie jednakowo edytując jego własciwość "left". Zapamiętujemy że pierwszy panel ma wartość left np 10.56. Sprawdzamy dwa pozostałe jeżeli jest różnica wpisujemy wartość 10.56 do kazdej własciwości "left" pozostałych paneli typowania.

Edycję własciwości wywołujemy klkiając podwójnie na wartość lub wciskając klawisz "F2".

inspektor obiektów

Na tym etapie jeżeli nie mamy doświadczenia lepiej posłużyć się właśnie inspektorem obiektów. Łatwiej jest o precyzję w ustawieniach.

Jeżeli panel pierwszy drukuje prawidłowe wyniki a przesunięcia występują w pionie przesunięcia te można skorygować w inspektorze korygując wartość "top" lub myszką z klawiszem "ALT".

Jeżeli panel pierwszy rozciągałeś lub zwężałeś skoryguj w pozostałych panelach własciwości "width"(szerokość) i "height". (wysokość).

Po wszystkich korektach nie zapomnij zapisac projektu.

I TO BY BYŁO NA TYLE